function countNeighborsIncl (cells, y, x) {
  count = 0;
  for (i = y-1; i <= y+1; i++) {
    for (j= x-1; j <= x+1; j++) {
      if (cells[i][j]) {
        count++;
      }
    }
  }
  return count;
}

function newCellValue (cells, y, x) {
  neighbors = countNeighborsIncl (cells, y, x);
  if (cells[y][x]) {
    neighbors = neighbors-1; // current cell does not count
    return (neighbors == 2) || (neighbors == 3);
  }
  else {
    return (neighbors == 3);
  }
}

SIZE_X = world.getSizeX();
SIZE_Y = world.getSizeY();

// use the following code to initialize the 
// world with random pattern
/*
for (y = 1; y < SIZE_Y-1; y++) {
  for (x = 1; x < SIZE_X-1; x++) {
    r = tools.random(1);
    world.setLeaf (x, y, r == 1);
  }
}
tools.checkState();
*/

cells    = Array();
newCells = Array();

cells[0] = Array();
newCells[0] = Array();

for (y = 1; y < SIZE_Y-1; y++) {
  cells[y] = Array();
  newCells[y] = Array();
  for (x = 1; x < SIZE_X-1; x++) {
    cells[y][x] = world.isLeaf (x, y);
  }
}

cells[SIZE_Y-1] = Array();
newCells[SIZE_Y-1] = Array();

while (true) {
  for (y = 1; y < SIZE_Y-1; y++) {
    for (x = 1; x < SIZE_X-1; x++) {
      newCells[y][x] = newCellValue (cells, y, x);
    }
  }

  for (y = 1; y < SIZE_Y-1; y++) {
    for (x = 1; x < SIZE_X-1; x++) {
      cells[y][x] = newCells[y][x];
      world.setLeaf (x, y, cells[y][x]);
    }
  }
  tools.checkState();
}
