function test (x, y) {
  tmpX = 0, tmpY = 0;
  i = 0;

  do {
    i++;
    tmp2X = tmpX*tmpX - tmpY*tmpY + x;
    tmp2Y = 2*tmpX*tmpY + y;
    tmpX = tmp2X;
    tmpY = tmp2Y;
  } while (((tmpX*tmpX + tmpY*tmpY) <= 4) && (i < ITERATIONS));

  return  i;
}

function calculateMandelX (col) {
  return X_MIN + col * (X_MAX-X_MIN) / KARA_WIDTH;
}

function calculateMandelY (row) {
  return Y_MIN + row * (Y_MAX-Y_MIN) / KARA_HEIGHT;
}

ITERATIONS = 100;

X_MIN = -2;
X_MAX = 1.4;
Y_MIN = -2;
Y_MAX = 1.4;

KARA_WIDTH = world.getSizeX();
KARA_HEIGHT= world.getSizeY();

world.clearAll();

for (row = 0; row < KARA_HEIGHT; row++) {
  for (col = 0; col < KARA_WIDTH; col++) {
    x = calculateMandelX(col);
    y = calculateMandelY(row);

    i = test(x, y);
    if (i == ITERATIONS) {
      world.setLeaf(col, row, true);
      tools.checkState();
    }
  }
}


