def getNumber (y):
  length = 0
  for x in range (0, world.getSizeX()):
    if world.isLeaf (x, y):
      length = length + 1
  return length

def showNumbers (numbers):
  for y in range (0, world.getSizeY()):
    for x in range (0, world.getSizeX()):
      world.setLeaf (x, y, (x < numbers[y]))
  tools.checkState()

def permutateNumbers (numbers):
  for y in range (0, world.getSizeY()):
    numbers[y] = y
  for i in range (0, world.getSizeY()*10):
    u = tools.random (len (numbers)-1)
    v = tools.random (len (numbers)-1)
    swap (numbers, u, v)

def swap (numbers, index1, index2):
  temp            = numbers[index1]
  numbers[index1] = numbers[index2]
  numbers[index2] = temp

numbers = []
numbersSorted = 0

# In the case there is a bar diagram of leaves in the world: 
for y in range (0, world.getSizeY()):
  numbers.append (getNumber(y))

# otherwise, you can create one: 
permutateNumbers(numbers)

while not numbersSorted:
  numbersSorted = 1
  for i in range (0, len (numbers)-1):
    if numbers[i] > numbers[i+1]:
      swap (numbers, i, i+1)
      numbersSorted = 0
      showNumbers (numbers)
