function getNumber(y) {
  var length = 0;
  for (x = 0; x < world.getSizeX(); x++) {
    if (world.isLeaf (x, y)) {
      length++;
    }
  }
  return length;
}


function showNumbers (numbers) {
  for (y = 0; y < world.getSizeY(); y++) {
    for (x = 0; x < world.getSizeX(); x++) {
      world.setLeaf (x, y, (x < numbers[y]));
    }
  }
  tools.checkState();
}


function permutateNumbers (numbers) {
  for (y = 0; y < world.getSizeY(); y++) {
    numbers[y] = y;
  }
  for (i = 0; i < world.getSizeY()*10; i++) {
    u = tools.random (numbers.length-1);
    v = tools.random (numbers.length-1);
    swap (numbers, u, v);
  }
}


function swap (numbers, index1, index2) {
  temp            = numbers[index1];
  numbers[index1] = numbers[index2];
  numbers[index2] = temp;
}


numbers = Array();
numbersSorted = false;

// In the case there is a bar diagram of leaves in the world: 
for (y = 0; y < world.getSizeY(); y++) {
  numbers[y] = getNumber(y);
}

// otherwise, you can create one: 
// permutateNumbers(numbers);

while (!numbersSorted) {
  numbersSorted = true;
  for (i = 0; i < numbers.length-1; i++) {
    if (numbers[i] > numbers[i+1]) {
      swap (numbers, i, i+1);
      numbersSorted = false;
      showNumbers (numbers);
    }
  }
}
