def getNumber (world, y)
 length = 0
 for x in 0..world.getSizeX-1
   if world.isLeaf (x, y)
     length = length + 1
   end
 end
 return length

end

def showNumbers (world, tools, numbers)
 for y in 0..world.getSizeY-1
   for x in 0..world.getSizeX-1
     world.setLeaf (x, y, (x < numbers[y]))
   end
 end
 tools.checkState

end

def swap (numbers, index1, index2)
 temp            = numbers[index1]
 numbers[index1] = numbers[index2]
 numbers[index2] = temp
end

def permutateNumbers (world, tools, numbers)
 for y in 0..world.getSizeY-1
   numbers[y] = y
 end
 for i in 0..99
   u = tools.random (numbers.length-1)
   v = tools.random (numbers.length-1)
   swap (numbers, u, v)

 end
end

numbers = Array.new(world.getSizeY) { 0 }
numbersSorted = false

# In the case there is a bar diagram of leaves in the world:
for y in 0..world.getSizeY-1
 numbers[y] = getNumber(world, y)
end

# otherwise, you can create one:
permutateNumbers(world, tools, numbers)

while not numbersSorted
 numbersSorted = true
 for i in 0..numbers.length-2
   if numbers[i] > numbers[i+1]
     swap (numbers, i, i+1)
     numbersSorted = false
     showNumbers(world, tools, numbers)
   end
 end
end