#############################################################################
# Kara schaut dem "Spiel des Lebens" zu. Damit das Programm einfacher wird,
# greift das Programm direkt auf den "Speicher" der Welt zu. Dafr stehen
# einige Methoden des Objekts world zur Verfgung (siehe
# unten). Zudem muss regelmssig die Methode tools.checkState()
# aufgerufen werden. Diese Methode schaut auf den Geschwindigkeitsregler
# im RubyKara-Hauptprogramm und legt das Programm eine entsprechende
# Zeitdauer schlafen.
#############################################################################

def countNeighborsIncl(cells, y, x)
 count = 0
 for i in y-1..y+1
   for j in x-1..x+1
     if cells[i][j]
       count = count + 1
     end
   end
 end
 return count
end

def newCellValue(cells, y, x)
 neighbors = countNeighborsIncl (cells, y, x)
 if cells[y][x]
   neighbors -= 1
   result = ((neighbors==2) or (neighbors==3))
 else
   result = (neighbors==3)
 end
 return result
end

#############################################################################
# hier beginnt das Hauptprogramm
#############################################################################

size_x = world.getSizeX()
size_y = world.getSizeY()

cells = Array.new(size_y) { Array.new(size_x) { false } }
newCells = Array.new(size_y) { Array.new(size_x) { false } }

for y in 0..size_y-1
 for x in 0..size_x-1
   cells[y][x] = world.isLeaf(x, y)
 end
end

# mit dem folgenden Code kann die Welt zufllig
# initialisiert werden
#for y in 1..size_y-2
#  for x in 1..size_x-2
#    world.setLeaf(x, y, rand(2) == 1 ? true : false)
#    cells[y][x] = world.isLeaf(x, y)
#  end
#end
#tools.checkState()

while true
 for y in 1..size_y-2
   for x in 1..size_x-2
     newCells[y][x] = newCellValue(cells, y, x)
   end
 end

 for y in 1..size_y-2
   for x in 1..size_x-2
     cells[y][x] = newCells[y][x]
     world.setLeaf(x, y, cells[y][x])
   end
 end
 tools.checkState()
end